#include<iostream>
using namespace std;
int main()
{
    ios_base::sync_with_stdio();cin.tie(0);
    string s;
    cin>>s;

    int i,n=s.length();
    for(i=0;i<n/2&&s[i]==s[n-1-i];i++) ;
    int j=i; // pamti indeks prvog neslaganja

    // a[] - broj pojavljivanja svih slova od a[j] do a[n-1-j]
    int a[26];
    fill(a,a+26,0);
    for(i=j;i<n/2;i++) a[s[i]-'a']++,a[s[n-1-i]-'a']++;
    if(n%2) a[s[n/2]-'a']++;

    // b[] = a[]
    int b[26];
    for(int i=0;i<26;i++) b[i]=a[i];

    // resenje
    int ans=n-2*j;
    for(i=j;i<n/2&&(a[s[i]-'a']-=2)>=0;i++) ;
    ans=min(ans,n-j-i);
    for(i=j;i<n/2&&(b[s[n-1-i]-'a']-=2)>=0;i++) ;
    ans=min(ans,n-j-i);

    cout<<ans;
    return 0;
}